from pycompss.api.task import task
from pycompss.api.parameter import *

FILENAME1="file1"
FILENAME2="file2"
FILENAME3="file3"

def main_program():
    # Check and get parameters
    if len(sys.argv) != 5:
        usage()
        exit(-1) 
    N = int(sys.argv[1])
    counter1 = int(sys.argv[2])
    counter2 = int(sys.argv[3])
    counter3 = int(sys.argv[4])
    
    # Initialize counter files
    initializeCounters(counter1, counter2, counter3)
    print "Initial counter values:"
    printCounterValues()
      
    # Execute increment
    for i in range(N):
        increment(FILENAME1)
        increment(FILENAME2)
        increment(FILENAME3)
    
    # Write final counters state (sync)
    print "Final counter values:"
    printCounterValues()
    
       
def usage():
    print "[ERROR] Bad numnber of parameters"
    print "    Usage: increment <numIterations> <counterValue1> <counterValue2> <counterValue3>"

def initializeCounters(counter1, counter2, counter3):
    # Write value counter 1
    fos = open(FILENAME1, 'w')
    fos.write(str(counter1))
    fos.close()
    
    # Write value counter 2
    fos = open(FILENAME2, 'w')
    fos.write(str(counter2))
    fos.close()
    
    # Write value counter 3
    fos = open(FILENAME3, 'w')
    fos.write(str(counter3))
    fos.close()
    
def printCounterValues():
    from pycompss.api.api import compss_open
    
    # Read value counter 1
    fis = compss_open(FILENAME1, 'r+')
    counter1 = fis.read()
    fis.close()
    
    # Read value counter 1
    fis = compss_open(FILENAME2, 'r+')
    counter2 = fis.read()
    fis.close()
    
    # Read value counter 1
    fis = compss_open(FILENAME3, 'r+')
    counter3 = fis.read()
    fis.close()
    
    # Print values
    print "- Counter1 value is " + counter1
    print "- Counter1 value is " + counter2
    print "- Counter1 value is " + counter3

@task(filePath = FILE_INOUT)
def increment(filePath):
    # Read value
    fis = open(filePath, 'r')
    value = fis.read()
    fis.close()

    # Write value
    fos = open(filePath, 'w')
    fos.write(str(int(value) + 1))
    fos.close()


if __name__ == "__main__":
    main_program()
    
    
